#!/usr/bin/perl

use strict;
use warnings;

my $aln_dir = "/home/tanja/mirbase/aln_clustal/";

opendir ( my $dh, $aln_dir ) or die "Couldn't open dir $aln_dir: $!\n";
my @files = grep{! /^\./ && -f "$aln_dir/$_" } readdir( $dh );

closedir $dh;

my $dir_out = "/home/tanja/mirbase/stockholm/";
#my $file_out = "/home/tanja/mirbase/mirfam_sek";

#open my $fh_sto, ">", $file_out or die "Couldn't open file \"$file_out\": $!\n";
	
foreach my $file ( @files ) {
	$file =~ m/(.*).aln/;
	print $file, "\n";
	my $mir_fam = $1;
	my $file_out = $dir_out.$1.".stk";
	open my $fh_in, "<", $aln_dir.$file or die "Couldn't open file \"$file\": $!\n";
	open my $fh_sto, ">", $file_out or die "Couldn't open file \"$file_out\": $!\n";

	my @output = `/home/tanja/Software/ViennaRNA-2.1.6/Progs/RNAalifold --noPS -r $aln_dir$file`;
	
	$output[ 1 ] =~ m/(\S*)\s.*/;
#	print $output[ 1 ], "\n";
	my $struc = $1;
#	print $struc, "\n";
	print { $fh_sto } "# STOCKHOLM 1.0\n\n";
	print { $fh_sto } "#=GF ID   ", $mir_fam, "\n\n";
	my $length = 0;
	while ( my $line = <$fh_in> ){
		next if $line =~ m/CLUSTALW/;
		next if $line =~ m/^\n$/;
		chomp $line;
		$line =~ m/(\S*\s*)\S*/i;
		my $part = $1;
		$length = length $part;
		print { $fh_sto } $line, "\n";
	}
	my $spaces = $length - 12;
	print { $fh_sto } "#=GC SS_cons", " " x ( $length - 12), $struc, "\n", "//", "\n";

#	print { $fh_sto } $struc, "\n";
	close $fh_in;
	close $fh_sto;
}
#close $fh_sto;