#!/usr/bin/perl

use strict;
use warnings;

my $species = "oabi";

my $file_in_genes = "/home/tanja/holo_genomes_results/CNE/cne_closest_gene_unique_" . $species . ".tab";
open my $fh_in_genes, '<', $file_in_genes or die "Couldn't open file \"$file_in_genes\": $!\n";

my $file_in_cluster = "/home/tanja/holo_genomes_results/CNE/cne_in_cluster_unique_" . $species . ".txt";
open my $fh_in_cluster, '<', $file_in_cluster or die "Couldn't open file \"$file_in_cluster\": $!\n";

my $file_out_all = "/home/tanja/holo_genomes_results/CNE/cne_" . $species . "_lvsc_allcne_uniquec.csv";
open my $fh_out_all, '>', $file_out_all or die "Couldn't open file \"$file_out_all\": $!\n";

my $file_out_500 = "/home/tanja/holo_genomes_results/CNE/cne_" . $species . "_lvsc_500cne_unique.csv";
open my $fh_out_500, '>', $file_out_500 or die "Couldn't open file \"$file_out_500\": $!\n";

print { $fh_out_all } "Cluster Scaffold", "\t", "Cluster start", "\t", "Cluster end", "\t", "Number of CNEs", "\t", "Cluster length in bp", "\n";
print { $fh_out_500 } "Cluster Scaffold", "\t", "Cluster start", "\t", "Cluster end", "\t", "Number of CNEs", "\t", "Cluster length in bp", "\n";

my %cluster_header;
while ( my $line = <$fh_in_cluster> ) {
	chomp $line;
	if ( $line =~ m/^>/ ) {
		my @parts = split ( "\t", $line );
		my $key = $parts[ 0 ] . "\t" . $parts[ 1 ] . "\t" . $parts[ 2 ];
		$cluster_header{ $key } = $parts[ 3 ];
	}
}

while ( my $line = <$fh_in_genes> ) {
	chomp $line;
	if ( $line =~ m/^>/ ) {
		my @parts = split( "\t", $line );
		my $key = $parts[ 0 ] . "\t" . $parts[ 1 ] . "\t" . $parts[ 2 ];
		my $length = $parts[ 2 ] - $parts[ 1 ];
		my $cluster_count = $cluster_header{ $key };
		next if !$cluster_count;
		print { $fh_out_all } $parts[ 0 ], "\t", $parts[ 1 ], "\t", $parts[ 2 ], "\t", $cluster_count, "\t", $length, "\n";
		if ( $parts [ 1 ] >= 500000 && $parts[ 4 ] >= 500000 ) {
			print { $fh_out_500 } $parts[ 0 ], "\t", $parts[ 1 ], "\t", $parts[ 2 ], "\t", $cluster_count, "\t", $length, "\n";
		}
	}
}

close $fh_in_genes;
close $fh_in_cluster;
close $fh_out_all;
close $fh_out_500;