use strict;
use warnings;
use Number::Range;

my $species = "amel";

my $CNE_file_one   		= "/home/tanja/holo_genomes_results/CNE/Amel_Oabi/CNE_first_second_70_100.bed";
my $CNE_file_two   		= "/home/tanja/holo_genomes_results/CNE/Amel_Aros/CNE_first_second_70_100.bed";
my $CNE_file_three 		= "/home/tanja/holo_genomes_results/CNE/Amel_Nvit/CNE_first_second_70_100.bed";
my $cluster_file		= "/home/tanja/holo_genomes_results/CNE/cne_in_cluster_unique_" . $species . ".txt";

open my $fh_cne_file_one, '<', $CNE_file_one or die "Couldn't open file \"$CNE_file_one\": $!\n";
open my $fh_cne_file_two, '<', $CNE_file_two or die "Couldn't open file \"$CNE_file_two\": $!\n";
open my $fh_cne_file_three, '<', $CNE_file_three or die "Couldn't open file \"$CNE_file_three\": $!\n";
open my $fh_cluster_file, '<', $cluster_file or die "Couldn't open file \"$cluster_file\": $!\n";

my %CNE_one;
my %CNE_two;
my %CNE_three;
my %CNE_cluster;

my $scaffold = '';
while ( my $line = <$fh_cluster_file> ) {
	chomp $line;
	if ( $line =~ m/^>/i ) {
		my @parts = split ( "\t", $line );
		$parts[ 0 ] =~ m/^>(.*)/i;
		$scaffold = $1;
	}
	else {
		my @parts = split ( "\t", $line );
		push @{ $CNE_cluster{ $scaffold } }, { 'start' => $parts[ 0 ], 'end' => $parts[ 1 ] };
	}
}

while ( my $line = <$fh_cne_file_one> ) {
	next if $line =~ m/^track/i;
	chomp $line;
	my @parts = split ( "\t", $line );
	push @{ $CNE_one{ $parts[ 0 ] } }, { 'start' => $parts[ 1 ], 'end' => $parts[ 2 ], 'match' => $parts[ 3 ] };
}

while ( my $line = <$fh_cne_file_two> ) {
	next if $line =~ m/^track/i;
	chomp $line;
	my @parts = split ( "\t", $line );
	push @{ $CNE_two{ $parts[ 0 ] } }, { 'start' => $parts[ 1 ], 'end' => $parts[ 2 ], 'match' => $parts[ 3 ] };
}

while ( my $line = <$fh_cne_file_three> ) {
	next if $line =~ m/^track/i;
	chomp $line;
	my @parts = split ( "\t", $line );
	push @{ $CNE_three{ $parts[ 0 ] } }, { 'start' => $parts[ 1 ], 'end' => $parts[ 2 ], 'match' => $parts[ 3 ] };
}

close $fh_cluster_file;
close $fh_cne_file_one;
close $fh_cne_file_two;
close $fh_cne_file_three;

my $file_cne_match_one   = "/home/tanja/holo_genomes_results/CNE/cne_match_one_2_" . $species . ".tab";
my $file_cne_match_two   = "/home/tanja/holo_genomes_results/CNE/cne_match_two_2_" . $species . ".tab";
my $file_cne_match_three = "/home/tanja/holo_genomes_results/CNE/cne_match_three_2_" . $species . ".tab";

open my $fh_cne_match_one, '>', $file_cne_match_one or die "Couldn't open file \"$file_cne_match_one\": $!\n";
open my $fh_cne_match_two, '>', $file_cne_match_two or die "Couldn't open file \"$file_cne_match_two\": $!\n";
open my $fh_cne_match_three, '>', $file_cne_match_three or die "Couldn't open file \"$file_cne_match_three\": $!\n";
my %CNE_one_adap;
my %CNE_two_adap;
my %CNE_three_adap;

foreach my $key ( sort keys %CNE_one ) {
	print $key, "\n";
	for ( my $i = 0; $i < scalar @{ $CNE_one{ $key } }; ++$i ) {
		print "i: ", $i, "\n";
		for ( my $j = 0; $j < scalar @{ $CNE_cluster{ $key } }; ++$j ) {
			my $range1 = Number::Range->new( $CNE_one{ $key }[ $i ]{ 'start' }..$CNE_one{ $key }[ $i ]{ 'end' } );
			my $range2 = Number::Range->new ( $CNE_cluster{ $key }[ $j ]{ 'start' }..$CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange1 = $range1->inrange( $CNE_cluster{ $key }[ $j ]{ 'start' }, $CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange2 = $range2->inrange( $CNE_one{ $key }[ $i ]{ 'start' }, $CNE_one{ $key }[ $i ]{ 'end' } );
			if ( $inrange1[ 0 ] == 1 or $inrange1[ 1 ] == 1 or $inrange2[ 0 ] == 1 or $inrange2[ 1 ] == 1 ) {
				my $key2 = $key . "_" . $CNE_cluster{ $key }[ $j ]{ 'start' } . "_" . $CNE_cluster{ $key }[ $j ]{ 'end' };
				$CNE_one_adap{ $key2 } += 1;
#				print "found!\n";
				print { $fh_cne_match_one } $key, "\t", $CNE_cluster{ $key }[ $j ]{ 'start' }, "\t", $CNE_cluster{ $key }[ $j ]{ 'end' }, "\n";
				last;
			}
		}
	}
}

foreach my $key ( sort keys %CNE_two ) {
	print $key, "\n";
	for ( my $i = 0; $i < scalar @{ $CNE_two{ $key } }; ++$i ) {
		print "i: ", $i, "\n";
		for ( my $j = 0; $j < scalar @{ $CNE_cluster{ $key } }; ++$j ) {
			my $range1 = Number::Range->new( $CNE_two{ $key }[ $i ]{ 'start' }..$CNE_two{ $key }[ $i ]{ 'end' } );
			my $range2 = Number::Range->new ( $CNE_cluster{ $key }[ $j ]{ 'start' }..$CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange1 = $range1->inrange( $CNE_cluster{ $key }[ $j ]{ 'start' }, $CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange2 = $range2->inrange( $CNE_two{ $key }[ $i ]{ 'start' }, $CNE_two{ $key }[ $i ]{ 'end' } );
			if ( $inrange1[ 0 ] == 1 or $inrange1[ 1 ] == 1 or $inrange2[ 0 ] == 1 or $inrange2[ 1 ] == 1 ) {
				my $key2 = $key . "_" . $CNE_cluster{ $key }[ $j ]{ 'start' } . "_" . $CNE_cluster{ $key }[ $j ]{ 'end' };
				$CNE_two_adap{ $key2 } += 1;
#				print "found!\n";
				print { $fh_cne_match_two } $key, "\t", $CNE_cluster{ $key }[ $j ]{ 'start' }, "\t", $CNE_cluster{ $key }[ $j ]{ 'end' }, "\n";
				last;
			}
		}
	}
}

foreach my $key ( sort keys %CNE_three ) {
	print $key, "\n";
	for ( my $i = 0; $i < scalar @{ $CNE_three{ $key } }; ++$i ) {
		print "i: ", $i, "\n";
		for ( my $j = 0; $j < scalar @{ $CNE_cluster{ $key } }; ++$j ) {
			my $range1 = Number::Range->new( $CNE_three{ $key }[ $i ]{ 'start' }..$CNE_three{ $key }[ $i ]{ 'end' } );
			my $range2 = Number::Range->new ( $CNE_cluster{ $key }[ $j ]{ 'start' }..$CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange1 = $range1->inrange( $CNE_cluster{ $key }[ $j ]{ 'start' }, $CNE_cluster{ $key }[ $j ]{ 'end' } );
			my @inrange2 = $range2->inrange( $CNE_three{ $key }[ $i ]{ 'start' }, $CNE_three{ $key }[ $i ]{ 'end' } );
			if ( $inrange1[ 0 ] == 1 or $inrange1[ 1 ] == 1 or $inrange2[ 0 ] == 1 or $inrange2[ 1 ] == 1 ) {
				my $key2 = $key . "_" . $CNE_cluster{ $key }[ $j ]{ 'start' } . "_" . $CNE_cluster{ $key }[ $j ]{ 'end' };
				$CNE_three_adap{ $key2 } += 1;
#				print "found!\n";
				print { $fh_cne_match_three } $key, "\t", $CNE_cluster{ $key }[ $j ]{ 'start' }, "\t", $CNE_cluster{ $key }[ $j ]{ 'end' }, "\n";
				last;
			}
		}
	}
}

close $fh_cne_match_one;
close $fh_cne_match_two;
close $fh_cne_match_three;

exit;
my %cne_all;

foreach my $key (sort keys %CNE_one_adap ) {
	if (exists $CNE_two_adap{ $key } && exists $CNE_three_adap{ $key } ) {
		$cne_all{ $key } += 1;
	}
}
foreach my $key ( sort keys %CNE_two_adap ) {
	if ( exists $CNE_one_adap{ $key } && exists $CNE_three_adap{ $key } ) {
		$cne_all{ $key } += 1;
	}
}
foreach my $key ( sort keys %CNE_three_adap ) {
	if ( exists $CNE_one_adap{ $key } && exists $CNE_two_adap{ $key } ) {
		$cne_all{ $key } += 1;
	}
}
my $cne_all_out = "/home/tanja/holo_genomes_results/CNE/cne_match_all_2_" . $species . ".tab";
open my $fh_cne_out, '>', $cne_all_out or die "Couldn't open file \"$cne_all_out\": $!\n";

foreach my $key (sort keys %cne_all ) {
	print { $fh_cne_out } $key, "\n";
}
close $fh_cne_out;

exit;